<?php

//#####################
//General functions like UI and SQL stuff
//#####################

require_once("class_bbparser.inc.php");
require_once("bittorrent.inc.php");
require_once("class.phpmailer.php");

$err_count = 0;
$header_shown = false;

global $gzip_compression_level;
if ((!isset($_GLOBAL["disable_gzip"])) && $gzip_compression_level != -1)
{
	//start_gzip();
}

//returns true if the current user has agreed to the rules
function has_agreed_rules()
{
	global $CURUSER;
	return (safequery_scalar("SELECT has_agreed_rules FROM user WHERE id = " . $CURUSER["id"] . " LIMIT 1") == 1);
}


//error-safe file write wrapper
function write_file($filename, $contents)
{
	if (!$handle = fopen($filename, 'w'))
		showerror("Cannot open file ($filename) for write access");
	
	if (fwrite($handle, $contents) === FALSE)
		showerror("Cannot write to file $filename");
	
	fclose($handle);
}

function safequery($sql)
{
	$ret = mysql_query($sql);

	if (!$ret)
	{
	showerror(mysql_error(), $sql);
		die();
	}

	global $fulldebug;

	if ($fulldebug && istrusted())
		echo("SQL: " . $sql . "<br>");

	return $ret;
}

function show_connectable($is_connectable)
{
	if ($is_connectable)
		echo "<font color=\"#00ff00\">works</font>";
	else
		echo "<font color=\"#ff0000\">firewalled</font>";
}

//gets the upload/download stats for given user
function get_ud_stats_by_user($user_id)
{
	return get_ud_stats("user_id = " . $user_id);
}

function update_user_small_stats_str($terms)
{
	$res = get_ud_stats($terms, " ORDER BY user_id", "");
	while ($row = mysql_fetch_array($res))
	{
		$user_id = $row["user_id"];
		$filename = "include/user_stats/".$user_id.".inc";
		write_file($filename, get_user_small_stats_str($row));
	}
}

function get_user_small_stats_str($row)
{
	return	"UL: " . mksize($row["total_ul_kb"] * 1024) . 
		" DL: " . mksize($row["total_dl_kb"] * 1024) .
		" <a href=\"faq.php#ratios\">Ratio</a>: " . show_ratio($row) . "</a>\n";
}

//gets U/D stats by custom terms
function get_ud_stats($terms, $orderby = "", $limit = " LIMIT 1")
{
	/*
	CREATE TABLE `user_ratio` (
		`user_id` int(10) unsigned NOT NULL default '0',
		`permanent_ul_kb` int(10) unsigned NOT NULL default '0',
		`permanent_dl_kb` int(10) unsigned NOT NULL default '0',
		`temp_ul_kb` int(10) unsigned NOT NULL default '0',
		`temp_dl_kb` int(10) unsigned NOT NULL default '0',
		`finished_dl_count` int(10) unsigned NOT NULL default '0',
		`failed_dl_count` int(10) unsigned NOT NULL default '0',
		`temp_updated` datetime default NULL,
		updated
	*/
	return safequery(
		"SELECT		user_id".
		",			permanent_ul_kb".
		",			permanent_dl_kb".
		",			temp_ul_kb".
		",			temp_dl_kb".
		",			finished_dl_count".
		",			failed_dl_count".
		",			(permanent_ul_kb + temp_ul_kb) AS total_ul_kb".
		",			(permanent_dl_kb + temp_dl_kb) AS total_dl_kb".
		",			(permanent_ul_kb + temp_ul_kb) / (permanent_dl_kb + temp_dl_kb + 1) AS ratio".
		",			updated".
		" FROM		user_ratio".
		" WHERE		" . $terms .
		$orderby .
		$limit
		);
}

//gets some plain text information about given ratio row
function get_ratio_info($row)
{
	global $min_dl_warning_kb;
	$dl_amount_full = ($row["total_dl_kb"] >= $min_dl_warning_kb);
	$ratio = $row["ratio"];
	if ($ratio < 0.5)
	{
		$text = "dangerously low";
		$warning_level = 1;
	}
	else if ($ratio < 0.8)
	{
		$text = "poor";
		$warning_level = 2;
	}
	else if ($ratio < 1)
	{
		$text = "under recommendation";
		$warning_level = 3;
	}
	else if ($ratio < 1.2)
	{
		$text = "ok";
		$warning_level = 4;
	}
	else if ($ratio < 2)
	{
		$text = "good";
		$warning_level = 0;
	}
	else if ($ratio < 5)
	{
		$text = "great";
		$warning_level = 0;
	}
	else
	{
		$text = "awesome";
		$warning_level = 0;
	}
	
	if ($dl_amount_full && $warning_level > 0)
	{
		$dl_amount_txt = "downloaded amount is already " . mksize($row["total_dl_kb"] * 1024);
		
		$ul_required_kb = $row["total_dl_kb"] - $row["total_ul_kb"];
		$ul_required_text = "Should upload " . mksize($ul_required_kb * 1024) . " more to gain the minimum 1:1 ratio";
		
		if ($warning_level <= 2)
			return "<b><font color=\"#ff0000\">WARNING: ratio is " . $text . " and " . $dl_amount_txt . ". " . $ul_required_text . "</font></b>";
		else
			return "NOTE: ratio is " . $text . " and " . $dl_amount_txt . ". " . $ul_required_text;
	}
	else
	{
		$str = "<font size=\"1\">Ratio is " . $text;
		if ($warning_level > 0)
		{
			$str .= " but it's not yet a problem because downloaded amount is only " . mksize($row["total_dl_kb"] * 1024);
		}
		return $str . "</font>";
	}
}

function show_ratio($row, $show_info = true)
{
	if ($row["total_dl_kb"] == 0)
	{
		if ($row["total_ul_kb"] == 0)
		{
			return "N/A";
		}
		else
		{
			return "<font color=\"#00ff00\">Infinite</font>";
		}
	}
	else
	{
		$ratio = $row["ratio"];
		$shown_ratio = round($ratio, 2);
		if ($ratio < 0.3)
			$color = "ff0000";
		else if ($ratio < 0.6)
			$color = "ee0000";
		else if ($ratio < 1)
			$color = "dd0000";
		else if ($ratio < 1.2)
			$color = "0000ee";
		else if ($ratio < 1.8)
			$color = "00dd00";
		else if ($ratio < 2.5)
			$color = "00ee00";
		else
			$color = "00ff00";
		
		$str = "<font color=\"#$color\">" . $ratio . "</font>";
		
		if ($show_info)
			$str .= "<br>\n" . get_ratio_info($row);
		
		return $str;
	}
}

function show_ud_stats_row($row, $show_user)
{
	echo "<tr>\n";
	if ($show_user)
		echo "	<td>" . userlink($row["user_id"], $row["username"]) . "</td>\n";
	
	echo "	<td>" . show_ratio($row) . "</td>\n";
	echo "	<td>" . mksize($row["total_ul_kb"] * 1024) . "</td>\n";
	echo "	<td>" . mksize($row["total_dl_kb"] * 1024) . "</td>\n";
	echo "	<td>" . $row["finished_dl_count"] . "</td>\n";
	echo "	<td>" . $row["failed_dl_count"] . "</td>\n";
	echo "	<td>" . mksize($row["temp_ul_kb"] * 1024) . "</td>\n";
	echo "	<td>" . mksize($row["temp_dl_kb"] * 1024) . "</td>\n";
	echo "	<td>" . mksize($row["permanent_ul_kb"] * 1024) . "</td>\n";
	echo "	<td>" . mksize($row["permanent_dl_kb"] * 1024) . "</td>\n";
	echo "	<td>" . $row["updated"] . "</td>\n";
	echo "</tr>\n";
}

function show_ud_stats_cols($show_user)
{
	echo "<tr>\n";
	if ($show_user)
		echo "	<td>User</td>\n";
	echo "	<td>Ratio</td>\n";
	echo "	<td>Total upload</td>\n";
	echo "	<td>Total download</td>\n";
	echo "	<td>Total finished downloads</td>\n";
	echo "	<td>Failed downloads</td>\n";
	echo "	<td>Total active upload</td>\n";
	echo "	<td>Total active download</td>\n";
	echo "	<td>Total older upload</td>\n";
	echo "	<td>Total older download</td>\n";
	echo "	<td>Stats updated at</td>\n";
	echo "</tr>\n";
}

function show_ud_stats_table($res, $show_user = false)
{
	echo "<table border=\"1\">";
	show_ud_stats_cols($show_user);
	while($row = mysql_fetch_array($res))
	{
		show_ud_stats_row($row, $show_user);
	}
	echo "</table>";
}

//sets gzip compression on
function start_gzip()
{
	global $gzip_compression_level;
	ini_set('zlib.output_compression_level', $gzip_compression_level);
	ob_start("ob_gzhandler");
}

function show_availability($seeders, $leechers)
{
	if ($leechers == 0)
		$leechers = 0.01;	//to avoid div. by zero
	
	if ($seeders == 0)
	{
		return "<font color=\"#ff0000\"><b>DEAD</b></font>";
	}
	else if (($seeders > 1 && $leechers < 1) || ($seeders > 1 && ($seeders / $leechers) >= 2 ))
	{
		return "<font color=\"#00ff00\">excellent</font>";
	}
	else if ((($seeders / $leechers) > 1 || $leechers < 1))
	{
		return "<font color=\"#00dd00\">good</font>";
	}
	else if (($seeders / $leechers) >= 0.3)
	{
		return "<font color=\"#22aa00\">ok</font>";
	}
	else
	{
		return "<font color=\"#aaaa00\">slow</font>";
	}
}

function update_feedback_count()
{
        $row = mysql_fetch_array(safequery("SELECT COUNT(*) FROM feedback WHERE is_done = 0"));
        $count = $row[0];

        if ($count == 0)
                $countstr = "";
        else
                $countstr = " (".$count." new)";

        shell_exec("echo \"".$countstr."\">undone_feedback_count.txt.inc");
}

function loggedonly()
{
        if (!islogged())
	{
		error_404();
		//returnto("login.php?returnto=" . urlencode($_SERVER["REQUEST_URI"]));
                exit();
        }
}

function islogged()
{
	global $CURUSER;
	return isset($CURUSER);
}

//returns true if the IP address is a local area network IP
function islocalip($ip)
{
        $arr = explode(".", $ip);
        if ($arr[0] == "10" || $arr[0] == "192" || $arr[0] == "127" || $arr[0] == "172")        //add other ranges here if you want
                return true;
        else
                return false;
}

function mail2($address, $body, $subject)
{
        $mail = new PHPMailer();
	global $tracker_title, $publichost, $smtp_server;
        $mail->From     = "noreply@".$publichost;
        $mail->FromName = $tracker_title;
        $mail->Host     = $smtp_server;
        $mail->Mailer   = "smtp";
        $mail->Subject  = $subject;
	
        $mail->Body    = $body;
        $mail->AddAddress($address, "");
	
        if(!$mail->Send())
        {
                echo "There has been a mail error sending to " . $address . "<br>";
                return false;
        }
        else
                return true;
}

function showheader($title)
{
	header("Content-Type: text/html; charset=iso-8859-1");
	global $CURUSER;
	global $header_shown;
	if ($header_shown)
		return false;
	$header_shown = true;
        if (isset($CURUSER) && $CURUSER)
	{
		//current user is logged in, showing full header
		require_once("header_logged.inc.php");
                showloggedheader($title);
	}
        else
	{
		//current user is not logged in, showing plain header
		require_once("header_notlogged.inc.php");
                shownotloggedheader($title);
	}
	return true;
}

function generatepass()
{
	return str_rand(10, 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789');
}

/**
 * Return a random string
 *
 * @author       Aidan Lister <aidan@php.net>
 * @version      2.0
 * @param        int     $length  Length of the string you want generated
 * @param        string  $seeds   The seeds you want the string to be generated from
 */

function str_rand($length = 8, $seeds = 'abcdefghijklmnopqrstuvwxyz0123456789')
{
    $str = '';
    $seeds_count = strlen($seeds);
 
    // Seed
    list($usec, $sec) = explode(' ', microtime());
    $seed = (float) $sec + ((float) $usec * 100000);
    mt_srand($seed);
 
    // Generate
    for ($i = 0; $length > $i; $i++) {
        $str .= $seeds{mt_rand(0, $seeds_count - 1)};
    }
 
    return $str;
}

function plainconfirmation($message, $url, $title = null, $secs = 2)
{
	confirmation($message, $url, $title, $secs);
}

function confirmation($message, $url, $title = null, $secs = 2)
{
	global $header_shown;
	if (!$header_shown)
	{
		header('Cache-Control: no-cache, must-revalidate');
		header('Pragma: no-cache');
	}

	if ($title == null)
		$title = "Confirmation";
	if (!showheader($title))
		echo("<h2>".$title."</h2>");
	echo("<h4>".$message."</h4>");
	echo("<br>You will be redirected to <a href=\"$url\">$url</a> in $secs seconds...<br>");
	stdfoot();
	returnto($url, $secs);
}

function userlink($id, $username)
{
	if ($id == null || $username == null)
		return "nobody";
	
	global $CURUSER;
	if (currentadmin() || $id == $CURUSER["id"])
		return "<a href=\"user.php?id=$id\">$username</a>";
	else
		return "anonymous";
}

//shows category select dropdown list
function catselect($name, $firstvaluetext, $incfile, $default_value = 0, $default_text = "")
{
	//echo "name = $name";
        echo("<select class=\"input\" name=\"".$name."\">\n");
	if ($default_value == 0)
		echo("<option value=\"0\" SELECTED>$firstvaluetext</option>\r\n");
	else
		echo("<option value=\"0\">$firstvaluetext</option>\n");
	
	if ($default_value > 0)
	{
		//adding default value, possibly the old one if user is editing something?
		
		echo("<option value=\"".$default_value."\" SELECTED>" . $default_text . "</option>\r\n");
	}
	
        include($incfile);
	
        echo("</select>");
}

//displays the category in given row
//shows category with no images
//(removed image support from the original show_category function for optimized performance)
function show_category($row)
{
	global $tracker_path;
	echo	"[<a href=\"".$tracker_path."/?category1=" . $row["id"] . "\">" . 
		trim($row["name"]).
		"</a>]";
}

/*
//	######### categories with image support ##########
//		  uncomment to enable

//displays the category in given row
function show_category($row)
{
	$filename = "images/category_" . $row["id"] . ".jpg";
	global $tracker_path;
	$linkstart = "<a href=\"".$tracker_path."/?category1=" . $row["id"] . "\">";
	$linkend = "</a>";
	if (file_exists($filename))
	{
		echo($linkstart);
		echo("<img src=\"". $filename ."\" alt=\"" . $row["name"] . "\">");
		echo($linkend);
	}
	else
	{
		echo "[";
		echo $linkstart;
		echo trim($row["name"]);
		echo $linkend . "]";
	}
	
}
	################
*/

//Shows all categories of given torrent id as HTML links
function show_categories($res)
{
	$cat_count = 0;
	echo "<font size=\"1\">\r\n";
	while ($row = mysql_fetch_array($res))
	{
		$cat_count++;
		show_category($row);
		echo("\r\n ");
	}
	
	if ($cat_count == 0)
		echo("No categories");
	
	echo "</font>\r\n";
}

function show_categories_by_torrent($torrent_id)
{
	$res = get_categories_by_torrent(
		$torrent_id,
		"category.id, category.name, category.is_abstract, category.owner_id",
		"category.searchable = 1");
	show_categories($res);
}

function get_categories_by_torrent(
	$torrent_id,
	$fields = "category.id, category.name, category.fullname, category.is_abstract",
	$extraterms = "1"
	)
{
	return safequery(
		"SELECT         $fields".
		" FROM          torrent_category".
		" LEFT JOIN     category".
		" ON            category.id = torrent_category.category_id".
		" WHERE         torrent_category.torrent_id = $torrent_id".
		" AND		$extraterms"
		);
	
	/*	WHOOPS! what the heck was I thinking here :P
	return safequery(
        	"SELECT         $fields".
		" FROM          torrent, torrent_category".
		" LEFT JOIN     category".
		" ON            category.id = torrent_category.category_id".
		" WHERE         torrent.id = $torrent_id".
		" AND           torrent_category.torrent_id = torrent.id"
		);
	*/
}

function get_categories_by_uploadrequest(
	$uploadrequest_id,
	$fields = "category.id, category.name, category.fullname, category.is_abstract",
	$orderby = ""
	)
{
	return safequery(
        	"SELECT         $fields".
		" FROM          uploadrequest_category".
		" LEFT JOIN     category".
		" ON            category.id = uploadrequest_category.category_id".
		" WHERE         uploadrequest_category.uploadrequest_id = $uploadrequest_id".
		" ORDER BY	uploadrequest_category.uploadrequest_id"
		);
}

function usererr($title = null, $message = "", $returnto = "")
{
	if ($title == null)
		$title = "Error in your request";
	
	stdhead($title);
	echo("<br><br><br><center>");
	echo("<p><font color=\"#ff0000\" size=\"3\">" . $message . "</font></p><br>\n");
	if ($returnto != "")
		echo("<br><br><a href=\"$returnto\">Back where you came from (data will be lost)</a>");
	echo("</center>");
	stdfoot();
	exit();
}

//forwards user to the given page
function returnto($url = "index.php", $secs = 0)
{
        header("Refresh: " . $secs . "; url=" . $url);
        exit;
}

//basic information from torrents
function get_torrents_basic(
	$terms,
	$limit = 0,
	$offset = 0,
	$orderby = "torrent.added DESC",
	$fields = null,
	$required_categories = null,
	$countonly = false
	)
{
	if ($required_categories != null && count($required_categories) > 0)
	{
		$terms .= " AND torrent.id IN (SELECT DISTINCT torrent_id FROM torrent_category WHERE category_id IN (";
		$cat_index = 0;
		foreach ($required_categories as $cat)
		{
			$cat_index++;
			if ($cat_index > 1)
				$terms .= ", ";
			$terms .= $cat;
		}
		$terms .= ") )";
	}
	if ($countonly == true)
	{
		$fields = "COUNT(torrent.id)";
		$groupby = "";
	}
	else
		$groupby = " GROUP BY      torrent.id";
	
	if ($fields == null || $fields == "")
		$fields =
			"torrent.id, torrent.name, torrent.visible, torrent.size, torrent.added, torrent.numfiles, torrent.views, ".
			"torrent.seeders, torrent.leechers, torrent.comments, user.id AS owner_id, user.username AS owner_username";
	
	if ($countonly)
		$limit = "";
	else
		$limit = " LIMIT         $limit".
		" OFFSET        $offset";
	
	$sql = 
		"SELECT 	" . $fields . 
		" FROM		torrent" .
		" LEFT JOIN	user".
		" ON		torrent.owner = user.id" .
		" WHERE 	" . $terms .
		$groupby.
		" ORDER BY 	$orderby" .
		$limit;
	
	return safequery($sql);
}

/*	OLD WAY
//basic information from torrents
function get_torrents_basic(
	$terms,
	$limit = 0,
	$offset = 0,
	$orderby = "torrent.added DESC",
	$fields = null,
	$joincat = true,
	$countonly = false
	)
{
	if ($countonly == true)
	{
		$fields = "COUNT(torrent.id)";
		$groupby = "";
	}
	else
		$groupby = " GROUP BY      torrent.id";
	
	if ($fields == null || $fields == "")
		$fields =
			"torrent.id, torrent.name, torrent.visible, torrent.size, torrent.added, torrent.numfiles, torrent.views, ".
			"torrent.seeders, torrent.leechers, torrent.comments, user.id AS owner_id, user.username AS owner_username";
	
	if ($joincat)
		$join = " CROSS JOIN torrent_category";
	else
		$join = "";
	
	if ($countonly)
		$limit = "";
	else
		$limit = " LIMIT         $limit".
		" OFFSET        $offset";
	
	if ($joincat)
		$terms .= " AND torrent.id = torrent_category.torrent_id AND torrent.id IS NOT NULL";
	$sql = 
		"SELECT 	" . $fields . 
		" FROM		torrent" .
		" LEFT JOIN	user".
		" ON		torrent.owner = user.id" .
		$join .
		" WHERE 	" . $terms .
		$groupby.
		" ORDER BY 	$orderby" .
		$limit;
	//echo($sql . "<br><br>");
	return safequery($sql);
}
*/

//returns number of rows shown
function show_torrents_result_basic($res)
{
	$rows = 0;
	show_torrent_columns_basic();
	
	while ($row = mysql_fetch_array($res))
	{
		$rows++;
		show_torrent_row_basic($row);
	}
	return $rows;
}

function show_torrent_row_basic($row)
{
	echo "<tr>\r\n";
	echo "	<td width=\"20%\">";
	show_categories_by_torrent($row["id"]);
	echo "	</td>";
	echo "	<td><a href=\"details.php?id=" . $row["id"] . "\">" . $row["name"] . "</a></td>\r\n";
	//echo "	<td>" . show_visible($row["visible"]) . "</td>\r\n";
	echo "	<td>" . show_availability($row["seeders"], $row["leechers"]) . "</td>\r\n";
	echo "	<td>" . mksize($row["size"]) . "</td>\r\n";
	echo "	<td>" . $row["numfiles"] . "</td>\r\n";
	echo "	<td>" . $row["added"] . "</td>\r\n";
	echo "	<td>" . $row["views"] . "</td>\r\n";
	echo "	<td>" . $row["seeders"] . "</td>\r\n";
	echo "	<td>" . $row["leechers"] . "</td>\r\n";
	echo "	<td>" . $row["comments"] . "</td>\r\n";
	echo "	<td>" . userlink($row["owner_id"], $row["owner_username"]) . "</td>\r\n";
	echo "</tr>\r\n";
}

function show_torrent_columns_basic()
{
	echo "<tr><td>Categories</td><td>Name</td><td>Availability</td><td>Size</td><td>Files</td><td>Added</td><td>Views</td><td>Seeders</td><td>Leechers</td><td>Comments</td><td>Uploader</td>";
}

function check_dict($str)
{
	if (trim($str) == "")
		return null;
	
	$str2 = strtolower(trim($str));
	
	global $cursewords;
	foreach ($cursewords as $curse)
	{
		//echo "checking curse '$curse' ... ";
		if (!(stripos($str2, $curse) === false))
			return "Curse word $curse was detected. How old were you anyway?";
	}
	return null;
}

function get_category_fullname($id)
{
	$res = safequery("SELECT fullname FROM category WHERE id = $id");
	if ($row = mysql_fetch_array($res))
		return $row["fullname"];
	else
		return "Category ID $id not found";
}

function get_category_shortname($id)
{
	$res = safequery("SELECT name FROM category WHERE id = $id");
	if ($row = mysql_fetch_array($res))
		return $row["name"];
	else
		return "Category ID $id not found";
}

/*
function get_category_shortname($id)
{
	$fn = "include/categories/".$id."_fullname.inc";
	if (!file_exists($fn))
		return "Can't find file $fn";
	
	$files = file($fn);
	return $files[0];
}
*/

function page_err($err)
{
	global $err_count;
	$err_count++;
	if ($err_count == 1)
		echo "Your request has the following errors:<br><br>";
	echo "- <font color=\"#ff0000\">".$err."</font><br><br>";
}

function show_catsearches($catsearches, $max_catsearches, $linebreak_every = 3)
{
        for ($k = 0; $k < $max_catsearches; $k++)
        {
                if (isset($catsearches[$k]))
                        $cat = $catsearches[$k];
                else
                        $cat = null;

                if ($k > 0)
                        echo " and \r\n";
		
                if ($cat == null)
                        catselect("category" . ($k + 1), "Any category", "cat.inc");
                else
                        catselect("category" . ($k + 1), "Any category", "cat.inc", $cat, get_category_fullname($cat));
		if ((($k + 1) % $linebreak_every) == 0 && $k != $max_catsearches)
			echo "<br>";
	}
}

function show_category_choices($catsearches, $max_catsearches, $linebreak_every = 3)
{
	$text = "Choose category";
        for ($k = 0; $k < $max_catsearches; $k++)
        {
                if (isset($catsearches[$k]))
                        $cat = $catsearches[$k];
                else
                        $cat = null;
		
		if ($k == 1)
			$text = "(optional)";

                if ($cat == null)
                        catselect("category" . ($k + 1), $text, "cat.inc");
                else
                        catselect("category" . ($k + 1), $text, "cat.inc", $cat, get_category_fullname($cat) . " (old value)");
		
		if ((($k+1) % $linebreak_every) == 0 && $k != $max_catsearches)
			echo "<br>";
	}
}

function parse_categories($arr, $max_catsearches)
{
        $catsearches = array();
        for ($k=1; $k<=$max_catsearches; $k++)
        {
                $cat = null;
                if (!empty($arr["category" . $k]))
                {
                        $cat = intval($arr["category" . $k]);
                        if ($cat > 0)
                        {
                                $catsearches[] = $cat;
                        }
                }
        }
        return $catsearches;
}

function addurl($name, $searchvalue = null)
{
        global $meurl;

        $meurl[$name] = urlencode($searchvalue);
}

function buildurl($extra_name = null, $extra_value = null)
{
        global $meurl;

        $str = "?";

        //adding new value in case it doesn't exist
        if ($extra_name != null && !isset($meurl[$extra_name]))
                $meurl[$extra_name] = $extra_value;

        foreach ($meurl as $name => $value)
        {
                if ($extra_name != null && $name == $extra_name)
                {
                        $value = $extra_value;
                }

                if ($str != "?")
                        $str .= "&";

                $str .= urlencode($name);
                if ($value != null)
                        $str .= "=" . urlencode($value);
        }
        return $str;
}

function debug_print($str)
{
	global $debug_ip;
	if (isset($debug_ip) && $_SERVER["REMOTE_ADDR"] == $debug_ip)
	{
		$debugstr =
			date("l dS of F Y h:i:s A") . "\r\n" . $_SERVER["REQUEST_URI"] . "\r\n" .
			"---------\r\n" . $str . "\r\n---------\r\n\r\n";
		$filename = "output_" . $debug_ip . ".log";
		$fp = fopen($filename, "a");
		if (fwrite($fp, $debugstr) === FALSE) {
			echo "Cannot write to file ($filename)";
			exit;
		}
	}
	print $str;
}

function build_page_browser($page, $total_pages)
{

	if ($total_pages <= 1)
	{
		$page_browsers = "";
	}
	else
	{
		$page_browsers = "<br>";
	
		if ($page == 1)
		{
			$page_browsers .= "First page | Previous page";
		}
		else
		{
			$page_browsers .= "<a href=\"" . buildurl("page", 1) . "\">First page</a>";
			if ($page > 1)
				$page_browsers .= " | <a href=\"" . buildurl("page", $page - 1) . "\">Previous page</a>";
		}
		
		for ($k = 1; $k <= $total_pages; $k++)
		{
			if ($k == $page)
			{
				$page_browsers .= " | <b>$k</b>";
			}
			else
			{
				$page_browsers .= " | <a href=\"" . buildurl("page", $k) . "\">" . $k. "</a>";
			}
		}
		
		if ($page == $total_pages)
		{
			$page_browsers .= "| Next page | Last page";
		}
		else
		{
			$page_browsers .= " | <a href=\"" . buildurl("page", $page + 1) . "\">Next page</a>";
			
			if ($page != $total_pages)
				$page_browsers .= "| <a href=\"" . buildurl("page", $total_pages) . "\">Last page</a>";
		}
		
		$page_browsers .= "<br><br>";
	}
	return $page_browsers;
}

function safequery_scalar($sql)
{
	$res = safequery($sql);
	if ($row = mysql_fetch_array($res))
		return $row[0];
	else
		showerror("safequery_scalar() got no rows", $sql);
}

function show_uploadrequest_status($status, $view_description = true)
{
	if ($status == "good")
		echo "<font color=\"#00ff00\">";
	else if ($status == "bad")
		echo "<font color=\"#ff0000\">";
	else if ($status == "ok")
		echo "<font color=\"#ffffff\">";
	else
		die("Unknown status $status");

	echo "<b>";
	echo $status;
	echo "</b></font>";
	if ($view_description)
	{
		echo "\n<font size=\"1\">(";
		if ($status == "good")
			echo "tracker has a nice set of requested torrents available";
		else if ($status == "bad")
			echo "tracker doesn't have much to offer";
		else if ($status == "ok")
			echo "tracker has something to offer";
		else
			die("Unknown status $status");
		
		echo ")</font>";
	}
}

//does the same as htmlspecialchars() but leaves some HTML intact, also parses URIs to links
function parse_comment($text)
{
	$bb = new BB_Parser;
	return $bb->parse($text);
}

?>
