<?
require_once('include/bittorrent.inc.php');
require_once('include/general_func.inc.php');

dbconn();

if (!islogged())
	returnto("login.php");

showheader("Torrent search");

$meurl = array();	//dynamically build this page URL (i.e. including search terms)

$terms = "1";		//dynamically build SQL WHERE terms

$errcount = 0;

function err($err)
{
	page_err($err);
	/*
	global $errcount;

	$errcount++;
	if ($errcount == 1)
		echo("<b>Your search has the following errors:</b><br><br>");
	
	echo("- $err<br><br>");
	*/
}

if (!empty($_GET["name"]))
{
	$search_name = trim($_GET["name"]);
	if (strlen(str_ireplace("*", "", $search_name)) < 2)
	{
		err("Name search too short. Must be at least 2 chars long. You don't want to kill our SQL server don't you?");
	}
	else
	{
		if (stripos($search_name, "*") === false)
			$search_name = "*" . $search_name . "*";
		
		//$search_name = str_ireplace("*", "%", $search_name);
		
		$terms .= " AND torrent.name LIKE '" . sqlesc2(str_ireplace("*", "%", str_ireplace("_", "\\_",str_ireplace("%", "\\%", $search_name)))) . "'";
	}
	addurl("name", $search_name);
}
else
{
	$search_name = "";
}

if (!empty($_GET["visible"]))
	$search_visible = $_GET["visible"];
else
	$search_visible = "yes";

if ($search_visible == "yes")
	$terms .= " AND torrent.visible = 'yes'";
else if ($search_visible == "no")
	$terms .= " AND torrent.visible = 'no'";
else
	$search_visible = "any";

if ($search_visible != "any")
	addurl("visible", $search_visible);

$uploader_username = "";
$myuploads = false;

if (!empty($_GET["uploader_username"]))
{
	if (!currentadmin())
	{
		err("Access denied for username search");
	}
	else
	{
		$uploader_username = trim($_GET["uploader_username"]);
		if ($uploader_username != "")
		{
			$res = safequery("SELECT id FROM user WHERE username LIKE '%" . sqlesc2($uploader_username) . "%'");
			if ($row = mysql_fetch_array($res))
			{
				$search_uploader = $row["id"];
			}
			else
			{
				err("No users matching \"$search_uploader\" were found");
			}
		}
	}
}
else if (isset($_GET["myuploads"]))
{
	$search_uploader = $CURUSER["id"];
	$myuploads = true;
	addurl("myuploads", null);
}

if (isset($search_uploader) && ($search_uploader > 0))
{
	if (currentadmin() || $search_uploader == $CURUSER["id"])
		$terms .= " AND torrent.owner = ".$search_uploader;
	else
		err("Access denied for torrent owner search, you can only search for your own torrents.");
}

$max_catsearches = 3;

$catsearches = parse_categories($_GET, $max_catsearches);

$k = 0;
foreach ($catsearches as $cat)
{
	$k++;
	addurl("category" . $k, $cat);
}

$catsearchon = count($catsearches) > 0;

if ($catsearchon)
	$catsearches = array_unique($catsearches);

/*
if ($catsearchon)
{
	$terms .= " AND (0";
}

foreach ($catsearches as $cat)
{
	$terms .= " OR torrent_category.category_id = $cat";
}

if ($catsearchon)
	$terms .= ")";
*/

$limit = 20;

$orderby = "torrent.added DESC";
/*
function get_torrents_basic(
        $terms,
        $limit = 0,
        $offset = 0,
        $orderby = "torrent.added DESC",
        $fields = null,
        $required_categories = null,
        $countonly = false
        )
*/
$row = mysql_fetch_row(get_torrents_basic($terms,0,0,"torrent.id",null, $catsearches, true));
$total_count = $row[0];

$total_pages = intval($total_count / $limit);
if (($total_count % $limit) > 0)
	$total_pages++;

if (isset($_GET["page"]) && intval($_GET["page"]) > 0)
{
	$page = $_GET["page"];
	if ($page > $total_pages)
		$page = $total_pages;
}
else
	$page = 1;

$offset = (($page - 1) * $limit);

if ($errcount == 0)
{
	$res = get_torrents_basic($terms,$limit,$offset,$orderby,null,$catsearches);
	$rows = mysql_num_rows($res);
}
?>
You may use * characters as wildcards. Searching for "someartist*" would find any torrent name starting with "someartist".<br>
<br>
<form action="./" method="get">
<br>
<table border="1">
<tr>
	<td>Torrent name</td>
	<td><input class="input" type="text" name="name" size="40" value="<?= htmlspecialchars($search_name) ?>" /></td>
</tr>
<tr>
	<td>Categories</td>
	<td>
<?php

show_catsearches($catsearches, $max_catsearches);

?>
	</td>
</tr>
<tr>
	<td>
		Uploader
	</td>
	<td><?php
		if (currentadmin())
		{?>
			Search by uploader username:<br>
			<input class="input" type="text" name="uploader_username" size="30" value="<?=htmlspecialchars($uploader_username)?>" /> or 
<?php		}
		if ($myuploads)
			$checkedstr = " CHECKED";
		else
			$checkedstr = "";
		echo("<input type=\"checkbox\" name=\"myuploads\" value=\"\" ".$checkedstr.">Show only my uploads</input>");
?>	</td>
</tr>
<tr>
	<td>
		Torrent alive
	</td>
	<td>
		<select class="input" name="visible">
<?php
			foreach (array("any", "yes", "no") as $str)
			{
				if ($search_visible == $str)
				{
					echo("			<option value=\"".$str."\" SELECTED>". $str . "</option>\r\n");
				}
				else
				{
					echo("			<option value=\"".$str."\">". $str . "</option>\r\n");
				}
			}
			/*
			*	<option value="any">Any</option>
			*	<option value="yes">Yes</option>
			*	<option value="no">No</option>
			*/

?>		
		</select>
		<font size="1">Choose whether you want to view only torrents that have been seeded recently.</font>
	</td>
</tr>
</table>
<br>
<table border="0">
<tr>
	<td>
			<input class="input" type="submit" value="Search" />
		</form>
	</td>
	<td>
		<form action="./" method="get">
			<input class="input" type="submit" value="View all alive torrents" />
		</form>
	</td>
	<td>
		<form action="./" method="get">
			<input class="input" type="hidden" name="myuploads" value="" />
			<input class="input" type="hidden" name="visible" value="no" />
			<input class="input" type="submit" value="View my dead torrents" />
		</form>
	</td>
</table>

<?php

//building page browser

$page_browser = build_page_browser($page, $total_pages);

echo "<br>\r\n";

if ($errcount > 0)
{
	echo $errcount." error(s)";
}
else if ($rows == 0)
{
	echo "No torrents found matching your search<br>";
}
else
{
	echo "Showing $rows of $total_count torrents matching your search<br>";
	echo $page_browser;

	echo "<table width=\"80%\">";

	show_torrents_result_basic($res);

	echo "</table>";

	echo $page_browser;
}

stdfoot();
?>
